varying highp vec2 textureCoordinate;
precision highp float;

uniform sampler2D original;
uniform sampler2D vignette;
uniform sampler2D surface;

highp vec4 desaturate(float sat, vec4 col)
{
    highp vec4 ret = vec4(0.0,0.0,0.0,0.0);
    float greyscale = dot(col.rgb, vec3(0.3, 0.59, 0.11));
    
    ret.rgb = mix(vec3(greyscale,greyscale,greyscale), col.rgb, sat);
    return ret;
}

void main()
{	
	highp vec4 col = texture2D(original, textureCoordinate)*1.6;
    col = desaturate(0.3,col);
    col = (col - 0.5)*0.8+0.5;
    
	highp vec4 vig = texture2D(vignette, textureCoordinate);
    highp vec4 surf = texture2D(surface, textureCoordinate);
    
    highp vec4 res = col * (1.0-vig) + 0.2*surf;
	gl_FragColor = vec4(res.r+0.1, res.g+0.05, res.b-0.15, 1.0);
    //gl_FragColor = col;
}
